#ifndef BIBLI_H

#define BIBLI_H

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>


#define N 4

typedef double matrix [N][N];
typedef double vector [N];

// à écrire dans affiche.c
void affiche_vect (vector t);
// donnée
void affiche_mat(matrix mat);
// à écrire
void affiche_syst(matrix mat,vector v);

// à écrire dans solveT.c
bool trig_inversible(matrix mat);
int cpx_trig_inversible(void);
// à écrire
void solveT(matrix a, vector b, vector r);
int cpx_solveT(void);

// à écrire dans triangulariser.c
void transvection_m(matrix a, int i, int j, double lm);
int cpx_transvection_m(void);
// à écrire
void transvection_v(vector v, int i, int j, double lm);
int cpx_transvection_v(void);
// à écrire
void swap_v (vector v, int i, int j);
int cpx_swap_v(void);
// à écrire  
void swap_m (matrix a, int i, int j);
int cpx_swap_m(void);
// à écrire
int pivot(matrix a, int i);

// à écrire
bool triangulariser(matrix a, vector b);
int cpx_triangulariser(void);

// à écrire dans synthese.c
bool resoudre(matrix a, vector b, vector r);
int cpx_resoudre(void);

// fonctions spéciales prof : dans affiche_prof.c. Elles ne sont pas à écrire
void affiche_vect_prof (vector t, FILE * fich);
void affiche_mat_prof(matrix mat, FILE * fich);
void affiche_syst_prof(matrix mat, vector v, FILE * fich);

#endif
