#include "bibli.h"



void bench_trig_inversible(char * file){
  printf("Création du fichier de tests %s\n",file);
  
  FILE* fich = fopen(file,"w");
  //fclose(fich);//le fichier est vidé ! malin si on a fait des tests avant !
  //FILE* fich = fopen(filename,"a");

  fprintf(fich,"BENCH_TRIG_INVERSIBLE\n");
  matrix mat;
  for (int i=0; i<N; i++)
    for (int j=0; j<N; j++){
      if (j<i) mat[i][j]=0.;
      else mat[i][j]=i*N+j+1;
    }
  affiche_mat_prof(mat,fich);
  fprintf(fich,"trig_inversible(mat)=%d\n",trig_inversible(mat));
  
  mat[1][1]=0;
  affiche_mat_prof(mat,fich);
  fprintf(fich,"trig_inversible(mat)=%d\n",trig_inversible(mat));

  mat[1][1]=5;
  mat[2][1]=1;
  affiche_mat_prof(mat,fich);
  fprintf(fich,"trig_inversible(mat)=%d\n",trig_inversible(mat));
  //points de complexité
  fprintf(fich,"cpx trig_inversible = %d\n",cpx_trig_inversible());
  fclose(fich);
}


void bench_solveT(char * file){// à appeler en second
  FILE* fich = fopen(file,"a");
  fprintf(fich,"BENCH_SOLVET\n");
  matrix t = {{1,  3, 1, -1},
	      {0, -2, 2, -2},
	      {0,  0, 5,  5},
	      {0,  0, 0, -1}};
  affiche_mat_prof(t,fich);
  fprintf(fich,"trig_inversible(t)=%d\n",trig_inversible(t));
  vector b = {1.,2.,-1,3.};
  affiche_vect_prof(b,fich);
  vector r;
  solveT(t,b,r);//-19.2,4.8,-3.
  fprintf(fich,"Solution de AX=B\n");
  affiche_vect_prof(r,fich);
  //points de complexité
  fprintf(fich,"cpx solve_T = %d\n",cpx_solveT());
  //pour tout le fichier testé : 10 lignes significatives
  fprintf(fich,"Nombre de lignes significatives : %d\n",10);
  fclose(fich);
}



int main(int argc, char* argv []){
  bench_trig_inversible(argv[1]);
  bench_solveT(argv[1]);
  return 0;
}
