#include "bibli.h"



void bench_transvection_v(char * file){
  printf("Création du fichier de tests %s\n",file);
  FILE* fich = fopen(file,"w");
  fprintf(fich,"BENCH_TRANSVECTION_V\n");
  vector v = {1.,2.,3.,5.};
  fprintf(fich,"la vecteur v avant transvection :\n");
  affiche_vect_prof(v,fich);
  fprintf(fich," L_2 <- L_2 -2L_0\n");
  transvection_v(v,2,0,-2);// L_2 <- L_2 -2L_0
  fprintf(fich,"le vecteur v après transvection :\n");
  affiche_vect_prof(v,fich);
  fprintf(fich,"cpx_transvection_v()=%d\n", cpx_transvection_v());
  fclose(fich);
}

void bench_transvection_m(char * file){
  FILE* fich = fopen(file,"a");
  fprintf(fich,"BENCH_TRANSVECTION_M\n");
  matrix a = {{1.,2.,0.,5.},{1.,0.,-1.,-6.},
	      {2.,1.,5.,0.},{4.,2.,1.,5.}};
  fprintf(fich,"la matrice a avant transvection :\n");
  affiche_mat_prof(a,fich);
  fprintf(fich," L_2 <- L_2 -2L_0\n");
  transvection_m(a,2,0,-2);// L_2 <- L_2 -2L_0
  fprintf(fich,"la matrice a après transvection :\n");
  affiche_mat_prof(a,fich);
  fprintf(fich,"cpx_transvection_m()=%d\n", cpx_transvection_m());
  fclose(fich);
}


void bench_swap_v(char * file){
  FILE* fich = fopen(file,"a");
  fprintf(fich,"BENCH_SWAP_V\n");
  vector v = {1.,2.,3.};
  affiche_vect_prof(v,fich);
  swap_v(v,0,2);
  fprintf(fich," swap_v(v,0,2)\n");
  affiche_vect_prof(v,fich);
  fprintf(fich,"cpx_swap_v()=%d\n", cpx_swap_v());
  fclose(fich);
}

void bench_swap_m(char * file){
  FILE* fich = fopen(file,"a");
  fprintf(fich,"BENCH_SWAP_M\n");
  matrix mat;
  for (int i=0; i<N; i++)
    for (int j=0; j<N; j++){
      if (j<i) mat[i][j]=0.;
      else mat[i][j]=i*N+j+1;
    }
  affiche_mat_prof(mat,fich);

  swap_m(mat,0,2);
  fprintf(fich," swap_m(m,0,2)\n");
  affiche_mat_prof(mat,fich);
  fprintf(fich,"cpx_swap_m()=%d\n", cpx_swap_m());
  //pour tout le fichier testé : 10 lignes significatives
  fprintf(fich,"Nombre de lignes significatives : %d\n",20);
  fclose(fich);
}

int main(int argc, char* argv []){
  bench_transvection_v(argv[1]);
  bench_transvection_m(argv[1]);
  bench_swap_v(argv[1]);
  bench_swap_m(argv[1]);
  return 0;
}
